package org.dromara.elevator.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.SpringUtils;
import org.dromara.common.core.utils.ValidatorUtils;
import org.dromara.common.excel.core.ExcelListener;
import org.dromara.common.excel.core.ExcelResult;
import org.dromara.elevator.domain.bo.EBuildingInfoBo;
import org.dromara.elevator.domain.vo.EBuildingInfoImportVo;
import org.dromara.elevator.domain.vo.EBuildingInfoVo;
import org.dromara.elevator.service.IEBuildingInfoService;

import java.util.List;

/**
 * 导入楼宇基础信息
 *
 * @author zy
 */
@Slf4j
public class EBuildingInfoImportListener extends AnalysisEventListener<EBuildingInfoImportVo> implements ExcelListener<EBuildingInfoImportVo> {

    private final IEBuildingInfoService buildingInfoService;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public EBuildingInfoImportListener(Boolean isUpdateSupport) {
        this.buildingInfoService = SpringUtils.getBean(IEBuildingInfoService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(EBuildingInfoImportVo buildingVo, AnalysisContext context) {

        EBuildingInfoVo buildingInfo = this.buildingInfoService.selectByCode(buildingVo.getCode());
        try {
            // 验证是否存在这个用户
            if (ObjectUtil.isNull(buildingInfo)) {
                EBuildingInfoBo building = BeanUtil.toBean(buildingVo, EBuildingInfoBo.class);
                ValidatorUtils.validate(building);
                buildingInfoService.insertByBo(building);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、楼宇 ").append(building.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long buildingId = buildingInfo.getId();
                EBuildingInfoBo buildingInfoBo = BeanUtil.toBean(buildingVo, EBuildingInfoBo.class);
                buildingInfoBo.setId(buildingId);
                ValidatorUtils.validate(buildingInfoBo);
                buildingInfoService.updateByBo(buildingInfoBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、楼宇 ").append(buildingVo.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、楼宇 ").append(buildingVo.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、楼宇 " + buildingVo.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<EBuildingInfoImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<EBuildingInfoImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
